import { r as t, i as e, h as i, H as r, g as o } from "./p-f3376aee.js";

// The programming goals of Split.js are to deliver readable, understandable and
// maintainable code, while at the same time manually optimizing for tiny minified file size,
// browser compatibility without additional requirements
// and very few assumptions about the user's page layout.
var s = "undefined" != typeof window ? window : null, n = null === s, l = n ? void 0 : s.document, NOOP = function() {
  return !1;
}, a = n ? "calc" : [ "", "-webkit-", "-moz-", "-o-" ].filter((function(t) {
  var e = l.createElement("div");
  return e.style.cssText = "width:" + t + "calc(9px)", !!e.style.length;
})).shift() + "calc", isString = function(t) {
  return "string" == typeof t || t instanceof String;
}, elementOrSelector = function(t) {
  if (isString(t)) {
    var e = l.querySelector(t);
    if (!e) throw new Error("Selector " + t + " did not match a DOM element");
    return e;
  }
  return t;
}, getOption = function(t, e, i) {
  var r = t[e];
  return void 0 !== r ? r : i;
}, getGutterSize = function(t, e, i, r) {
  if (e) {
    if ("end" === r) return 0;
    if ("center" === r) return t / 2;
  } else if (i) {
    if ("start" === r) return 0;
    if ("center" === r) return t / 2;
  }
  return t;
}, defaultGutterFn = function(t, e) {
  var i = l.createElement("div");
  return i.className = "gutter gutter-" + e, i;
}, defaultElementStyleFn = function(t, e, i) {
  var r = {};
  return isString(e) ? r[t] = e : r[t] = a + "(" + e + "% - " + i + "px)", r;
}, defaultGutterStyleFn = function(t, e) {
  var i;
  return (i = {})[t] = e + "px", i;
}, Split = function(t, e) {
  if (void 0 === e && (e = {}), n) return {};
  var i, r, o, a, c, h, d = t;
  // Allow HTMLCollection to be used as an argument when supported
  Array.from && (d = Array.from(d));
  // All DOM elements in the split should have a common parent. We can grab
  // the first elements parent and hope users read the docs because the
  // behavior will be whacky otherwise.
    var g = elementOrSelector(d[0]).parentNode, u = getComputedStyle ? getComputedStyle(g) : null, p = u ? u.flexDirection : null, f = getOption(e, "sizes") || d.map((function() {
    return 100 / d.length;
  })), b = getOption(e, "minSize", 100), y = Array.isArray(b) ? b : d.map((function() {
    return b;
  })), m = getOption(e, "maxSize", 1 / 0), v = Array.isArray(m) ? m : d.map((function() {
    return m;
  })), z = getOption(e, "expandToMin", !1), k = getOption(e, "gutterSize", 10), S = getOption(e, "gutterAlign", "center"), x = getOption(e, "snapOffset", 30), E = getOption(e, "dragInterval", 1), L = getOption(e, "direction", "horizontal"), C = getOption(e, "cursor", "horizontal" === L ? "col-resize" : "row-resize"), w = getOption(e, "gutter", defaultGutterFn), A = getOption(e, "elementStyle", defaultElementStyleFn), q = getOption(e, "gutterStyle", defaultGutterStyleFn);
  // 3. Define the dragging helper functions, and a few helpers to go with them.
  // Each helper is bound to a pair object that contains its metadata. This
  // also makes it easy to store references to listeners that that will be
  // added and removed.
  // Even though there are no other functions contained in them, aliasing
  // this to self saves 50 bytes or so since it's used so frequently.
  // The pair object saves metadata like dragging state, position and
  // event listener references.
  function setElementSize(t, e, r, o) {
    // Split.js allows setting sizes via numbers (ideally), or if you must,
    // by string, like '300px'. This is less than ideal, because it breaks
    // the fluid layout that `calc(% - px)` provides. You're on your own if you do that,
    // make sure you calculate the gutter size by hand.
    var s = A(i, e, r, o);
    Object.keys(s).forEach((function(e) {
      // eslint-disable-next-line no-param-reassign
      t.style[e] = s[e];
    }));
  }
  function getSizes() {
    return h.map((function(t) {
      return t.size;
    }));
  }
  // Supports touch events, but not multitouch, so only the first
  // finger `touches[0]` is counted.
    function getMousePosition(t) {
    return "touches" in t ? t.touches[0][r] : t[r];
  }
  // Actually adjust the size of elements `a` and `b` to `offset` while dragging.
  // calc is used to allow calc(percentage + gutterpx) on the whole split instance,
  // which allows the viewport to be resized without additional logic.
  // Element a's size is the same as offset. b's size is total size - a size.
  // Both sizes are calculated from the initial parent percentage,
  // then the gutter size is subtracted.
    function adjust(t) {
    var e = h[this.a], i = h[this.b], r = e.size + i.size;
    e.size = t / this.size * r, i.size = r - t / this.size * r, setElementSize(e.element, e.size, this._b, e.i), 
    setElementSize(i.element, i.size, this._c, i.i);
  }
  // drag, where all the magic happens. The logic is really quite simple:
  
  // 1. Ignore if the pair is not dragging.
  // 2. Get the offset of the event.
  // 3. Snap offset to min if within snappable range (within min + snapOffset).
  // 4. Actually adjust each element in the pair to offset.
  
  // ---------------------------------------------------------------------
  // |    | <- a.minSize               ||              b.minSize -> |    |
  // |    |  | <- this.snapOffset      ||     this.snapOffset -> |  |    |
  // |    |  |                         ||                        |  |    |
  // |    |  |                         ||                        |  |    |
  // ---------------------------------------------------------------------
  // | <- this.start                                        this.size -> |
    function drag(t) {
    var i, r = h[this.a], o = h[this.b];
    this.dragging && (
    // Get the offset of the event from the first side of the
    // pair `this.start`. Then offset by the initial position of the
    // mouse compared to the gutter size.
    i = getMousePosition(t) - this.start + (this._b - this.dragOffset), E > 1 && (i = Math.round(i / E) * E), 
    // If within snapOffset of min or max, set offset to min or max.
    // snapOffset buffers a.minSize and b.minSize, so logic is opposite for both.
    // Include the appropriate gutter sizes to prevent overflows.
    i <= r.minSize + x + this._b ? i = r.minSize + this._b : i >= this.size - (o.minSize + x + this._c) && (i = this.size - (o.minSize + this._c)), 
    i >= r.maxSize - x + this._b ? i = r.maxSize + this._b : i <= this.size - (o.maxSize - x + this._c) && (i = this.size - (o.maxSize + this._c)), 
    // Actually adjust the size.
    adjust.call(this, i), 
    // Call the drag callback continously. Don't do anything too intensive
    // in this callback.
    getOption(e, "onDrag", NOOP)(getSizes()));
  }
  // Cache some important sizes when drag starts, so we don't have to do that
  // continously:
  
  // `size`: The total size of the pair. First + second + first gutter + second gutter.
  // `start`: The leading side of the first element.
  
  // ------------------------------------------------
  // |      aGutterSize -> |||                      |
  // |                     |||                      |
  // |                     |||                      |
  // |                     ||| <- bGutterSize       |
  // ------------------------------------------------
  // | <- start                             size -> |
    function calculateSizes() {
    // Figure out the parent size minus padding.
    var t = h[this.a].element, e = h[this.b].element, r = t.getBoundingClientRect(), s = e.getBoundingClientRect();
    this.size = r[i] + s[i] + this._b + this._c, this.start = r[o], this.end = r[a];
  }
  // When specifying percentage sizes that are less than the computed
  // size of the element minus the gutter, the lesser percentages must be increased
  // (and decreased from the other elements) to make space for the pixels
  // subtracted by the gutters.
  function trimToMin(t) {
    // Try to get inner size of parent element.
    // If it's no supported, return original sizes.
    var e = function(t) {
      // Return nothing if getComputedStyle is not supported (< IE9)
      // Or if parent element has no layout yet
      if (!getComputedStyle) return null;
      var e = getComputedStyle(t);
      if (!e) return null;
      var i = t[c];
      return 0 === i ? null : i -= "horizontal" === L ? parseFloat(e.paddingLeft) + parseFloat(e.paddingRight) : parseFloat(e.paddingTop) + parseFloat(e.paddingBottom);
    }(g);
    if (null === e) return t;
    if (y.reduce((function(t, e) {
      return t + e;
    }), 0) > e) return t;
    // Keep track of the excess pixels, the amount of pixels over the desired percentage
    // Also keep track of the elements with pixels to spare, to decrease after if needed
        var i = 0, r = [], o = t.map((function(o, s) {
      // Convert requested percentages to pixel sizes
      var n = e * o / 100, l = getGutterSize(k, 0 === s, s === t.length - 1, S), a = y[s] + l;
      // If element is too smal, increase excess pixels by the difference
      // and mark that it has no pixels to spare
      return n < a ? (i += a - n, r.push(0), a) : (
      // Otherwise, mark the pixels it has to spare and return it's original size
      r.push(n - a), n);
    }));
    // If nothing was adjusted, return the original sizes
    return 0 === i ? t : o.map((function(t, o) {
      var s = t;
      // While there's still pixels to take, and there's enough pixels to spare,
      // take as many as possible up to the total excess pixels
            if (i > 0 && r[o] - i > 0) {
        var n = Math.min(i, r[o] - i);
        // Subtract the amount taken for the next iteration
                i -= n, s = t - n;
      }
      // Return the pixel size adjusted as a percentage
            return s / e * 100;
    }));
  }
  // stopDragging is very similar to startDragging in reverse.
    function stopDragging() {
    var t = h[this.a].element, i = h[this.b].element;
    this.dragging && getOption(e, "onDragEnd", NOOP)(getSizes()), this.dragging = !1, 
    // Remove the stored event listeners. This is why we store them.
    s.removeEventListener("mouseup", this.stop), s.removeEventListener("touchend", this.stop), 
    s.removeEventListener("touchcancel", this.stop), s.removeEventListener("mousemove", this.move), 
    s.removeEventListener("touchmove", this.move), 
    // Clear bound function references
    this.stop = null, this.move = null, t.removeEventListener("selectstart", NOOP), 
    t.removeEventListener("dragstart", NOOP), i.removeEventListener("selectstart", NOOP), 
    i.removeEventListener("dragstart", NOOP), t.style.userSelect = "", t.style.webkitUserSelect = "", 
    t.style.MozUserSelect = "", t.style.pointerEvents = "", i.style.userSelect = "", 
    i.style.webkitUserSelect = "", i.style.MozUserSelect = "", i.style.pointerEvents = "", 
    this.gutter.style.cursor = "", this.parent.style.cursor = "", l.body.style.cursor = "";
  }
  // startDragging calls `calculateSizes` to store the inital size in the pair object.
  // It also adds event listeners for mouse/touch events,
  // and prevents selection while dragging so avoid the selecting text.
    function startDragging(t) {
    // Right-clicking can't start dragging.
    if (!("button" in t) || 0 === t.button) {
      // Alias frequently used variables to save space. 200 bytes.
      var i = h[this.a].element, r = h[this.b].element;
      // Call the onDragStart callback.
      this.dragging || getOption(e, "onDragStart", NOOP)(getSizes()), 
      // Don't actually drag the element. We emulate that in the drag function.
      t.preventDefault(), 
      // Set the dragging property of the pair object.
      this.dragging = !0, 
      // Create two event listeners bound to the same pair object and store
      // them in the pair object.
      this.move = drag.bind(this), this.stop = stopDragging.bind(this), 
      // All the binding. `window` gets the stop events in case we drag out of the elements.
      s.addEventListener("mouseup", this.stop), s.addEventListener("touchend", this.stop), 
      s.addEventListener("touchcancel", this.stop), s.addEventListener("mousemove", this.move), 
      s.addEventListener("touchmove", this.move), 
      // Disable selection. Disable!
      i.addEventListener("selectstart", NOOP), i.addEventListener("dragstart", NOOP), 
      r.addEventListener("selectstart", NOOP), r.addEventListener("dragstart", NOOP), 
      i.style.userSelect = "none", i.style.webkitUserSelect = "none", i.style.MozUserSelect = "none", 
      i.style.pointerEvents = "none", r.style.userSelect = "none", r.style.webkitUserSelect = "none", 
      r.style.MozUserSelect = "none", r.style.pointerEvents = "none", 
      // Set the cursor at multiple levels
      this.gutter.style.cursor = C, this.parent.style.cursor = C, l.body.style.cursor = C, 
      // Cache the initial sizes of the pair.
      calculateSizes.call(this), 
      // Determine the position of the mouse compared to the gutter
      this.dragOffset = getMousePosition(t) - this.end;
    }
  }
  // adjust sizes to ensure percentage is within min size and gutter.
    // 2. Initialize a bunch of strings based on the direction we're splitting.
  // A lot of the behavior in the rest of the library is paramatized down to
  // rely on CSS strings and classes.
  "horizontal" === L ? (i = "width", r = "clientX", o = "left", a = "right", c = "clientWidth") : "vertical" === L && (i = "height", 
  r = "clientY", o = "top", a = "bottom", c = "clientHeight"), f = trimToMin(f);
  // 5. Create pair and element objects. Each pair has an index reference to
  // elements `a` and `b` of the pair (first and second elements).
  // Loop through the elements while pairing them off. Every pair gets a
  // `pair` object and a gutter.
  // Basic logic:
  // - Starting with the second element `i > 0`, create `pair` objects with
  //   `a = i - 1` and `b = i`
  // - Set gutter sizes based on the _pair_ being first/last. The first and last
  //   pair have gutterSize / 2, since they only have one half gutter, and not two.
  // - Create gutter elements and add event listeners.
  // - Set the size of the elements, minus the gutter sizes.
  // -----------------------------------------------------------------------
  // |     i=0     |         i=1         |        i=2       |      i=3     |
  // |             |                     |                  |              |
  // |           pair 0                pair 1             pair 2           |
  // |             |                     |                  |              |
  // -----------------------------------------------------------------------
  var T = [];
  function adjustToMin(t) {
    var e = t.i === T.length, i = e ? T[t.i - 1] : T[t.i];
    calculateSizes.call(i);
    var r = e ? i.size - t.minSize - i._c : t.minSize + i._b;
    adjust.call(i, r);
  }
  return (h = d.map((function(t, e) {
    // Create the element object.
    var r, o = {
      element: elementOrSelector(t),
      size: f[e],
      minSize: y[e],
      maxSize: v[e],
      i: e
    };
    if (e > 0 && (
    // Create the pair object with its metadata.
    (r = {
      a: e - 1,
      b: e,
      dragging: !1,
      direction: L,
      parent: g
    })._b = getGutterSize(k, e - 1 == 0, !1, S), r._c = getGutterSize(k, !1, e === d.length - 1, S), 
    "row-reverse" === p || "column-reverse" === p)) {
      var s = r.a;
      r.a = r.b, r.b = s;
    }
    // Determine the size of the current element. IE8 is supported by
    // staticly assigning sizes without draggable gutters. Assigns a string
    // to `size`.
    
    // Create gutter elements for each pair.
        if (e > 0) {
      var n = w(e, L, o.element);
      !function(t, e, r) {
        var o = q(i, e, r);
        Object.keys(o).forEach((function(e) {
          // eslint-disable-next-line no-param-reassign
          t.style[e] = o[e];
        }));
      }(n, k, e), 
      // Save bound event listener for removal later
      r._a = startDragging.bind(r), 
      // Attach bound event listener
      n.addEventListener("mousedown", r._a), n.addEventListener("touchstart", r._a), g.insertBefore(n, o.element), 
      r.gutter = n;
    }
    return setElementSize(o.element, o.size, getGutterSize(k, 0 === e, e === d.length - 1, S), e), 
    // After the first iteration, and we have a pair object, append it to the
    // list of pairs.
    e > 0 && T.push(r), o;
  }))).forEach((function(t) {
    var e = t.element.getBoundingClientRect()[i];
    e < t.minSize && (z ? adjustToMin(t) : 
    // eslint-disable-next-line no-param-reassign
    t.minSize = e);
  })), {
    setSizes: function(t) {
      var e = trimToMin(t);
      e.forEach((function(t, i) {
        if (i > 0) {
          var r = T[i - 1], o = h[r.a], s = h[r.b];
          o.size = e[i - 1], s.size = t, setElementSize(o.element, o.size, r._b, o.i), setElementSize(s.element, s.size, r._c, s.i);
        }
      }));
    },
    getSizes,
    collapse: function(t) {
      adjustToMin(h[t]);
    },
    destroy: function(t, e) {
      T.forEach((function(r) {
        if (!0 !== e ? r.parent.removeChild(r.gutter) : (r.gutter.removeEventListener("mousedown", r._a), 
        r.gutter.removeEventListener("touchstart", r._a)), !0 !== t) {
          var o = A(i, r.a.size, r._b);
          Object.keys(o).forEach((function(t) {
            h[r.a].element.style[t] = "", h[r.b].element.style[t] = "";
          }));
        }
      }));
    },
    parent: g,
    pairs: T
  };
};

const c = class {
  constructor(i) {
    t(this, i), this.dragging = e(this, "dragging", 7), this.dragEnded = e(this, "dragEnded", 7), 
    /**
         * The splitter direction
         */
    this.direction = "horizontal", 
    /**
         * The prescence of this attributes forces the splitter to collapse to zero
         */
    this.forceCollapseZero = !1, 
    /**
         * The type of knob (simple: only draggable - bidirectional: draggable and collapsable by clicking the arrows)
         */
    this.knob = "bidirectional", 
    /**
         * The splitter min. sizes in pixels
         */
    this.minSize = "0,0", 
    /**
         * The splitter initial sizes, in percentages. The sum should equal 100
         */
    this.sizes = "50,50", this.idsArray = [], this.draggingState = !1, this.leftCollapsedToZero = !1, 
    this.rightCollapsedToZero = !1;
  }
  makeId(t) {
    const e = [], i = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", r = i.length;
    for (let o = 0; o < t; o++) e.push(i.charAt(Math.floor(Math.random() * r)));
    // this prevents the id begining with a number, which is not allowed
    return e.unshift("a"), e.join("");
  }
  componentWillLoad() {
    this.el.querySelectorAll("gxg-split").forEach(function(t) {
      const e = this.makeId(5);
      t.setAttribute("id", e);
    }.bind(this));
  }
  componentDidLoad() {
    this.getIds(), this.convertStringPropertiesToArray(), this.validateSizes(), this.split = Split(this.idsArray, {
      gutterSize: 8,
      cursor: "col-resize",
      minSize: this.minSizeArray,
      sizes: this.sizesArray,
      direction: this.direction,
      onDragStart: this.onDragStartFunc.bind(this),
      onDrag: this.onDragFunc.bind(this),
      onDragEnd: this.onDragEndFunc.bind(this),
      gutter: () => {
        const t = document.createElement("div");
        if ("bidirectional" === this.knob) {
          //KNOB
          const e = document.createElement("span");
          e.classList.add("knob"), e.style.width = "var(--spacing-comp-05)", e.style.height = "var(--spacing-comp-05)", 
          e.style.display = "block", e.style.zIndex = "5", e.style.position = "absolute", 
          "vertical" === this.direction && (e.style.transform = "rotate(90deg)");
          //KNOB middle line
          const i = document.createElement("span");
          i.style.backgroundColor = "var(--gray-03)", i.style.width = "2px", i.style.height = "16px", 
          i.style.position = "relative", i.style.left = "11px", i.style.top = "4px", i.style.display = "block", 
          i.style.transition = "0.25s all", i.classList.add("middle-line"), e.appendChild(i);
          //KNOB left side
          const r = document.createElement("span");
          r.style.width = "11px", r.style.height = "var(--spacing-comp-05)", r.style.display = "block", 
          r.style.top = "-36px", r.style.left = "6px", r.style.position = "relative", r.style.borderBottomLeftRadius = "40px", 
          r.style.borderTopLeftRadius = "40px", r.style.backgroundColor = "transparent", r.style.cursor = "pointer", 
          r.style.zIndex = "20", r.style.pointerEvents = "auto", r.classList.add("left-knob"), 
          r.addEventListener("click", this.knobLeftClicked.bind(this)), r.onmouseover = this.knobLeftOver.bind(this), 
          r.onmouseout = this.knobLeftOut.bind(this), e.appendChild(r);
          //KNOB right side
          const o = document.createElement("span");
          o.style.width = "11px", o.style.height = "var(--spacing-comp-05)", o.style.display = "block", 
          o.style.top = "-20px", o.style.right = "-6px", o.style.position = "relative", o.style.borderBottomRightRadius = "40px", 
          o.style.borderTopRightRadius = "40px", o.style.backgroundColor = "transparent", 
          o.style.cursor = "pointer", o.style.zIndex = "20", o.style.pointerEvents = "auto", 
          o.classList.add("right-knob"), o.addEventListener("click", this.knobRightClicked.bind(this)), 
          o.onmouseover = this.knobRightOver.bind(this), o.onmouseout = this.knobRightOut.bind(this), 
          e.appendChild(o), t.appendChild(e);
        } else {
          //KNOB
          const e = document.createElement("span");
          e.classList.add("knob"), e.style.width = "var(--spacing-comp-05)", e.style.height = "var(--spacing-comp-05)", 
          e.style.display = "block", e.style.zIndex = "5", e.style.position = "absolute", 
          "vertical" === this.direction && (e.style.transform = "rotate(90deg)");
          //KNOB middle line
          const i = document.createElement("span");
          i.style.backgroundColor = "var(--gray-03)", i.style.width = "2px", i.style.height = "16px", 
          i.style.position = "relative", i.style.left = "11px", i.style.top = "4px", i.style.display = "block", 
          i.style.transition = "0.25s all", i.classList.add("middle-line"), e.appendChild(i), 
          t.appendChild(e);
        }
        return t.className = "gutter gutter-" + this.direction, t;
      }
    }), this.detectDragEndReachedMinimum();
    //set classes
    const t = this.el.querySelectorAll("gxg-split");
    "horizontal" === this.direction && t.forEach((function(t) {
      t.classList.add("split-horizontal");
    }));
  }
  convertStringPropertiesToArray() {
    this.minSizeArray = this.minSize.split(",").map((function(t) {
      return parseInt(t, 10);
    })), this.sizesArray = this.sizes.split(",").map((function(t) {
      return parseInt(t, 10);
    }));
  }
  getIds() {
    this.el.querySelectorAll("gxg-split").forEach(function(t) {
      const e = t.getAttribute("id");
      this.idsArray.push("#" + e);
    }.bind(this));
  }
  validateSizes() {
    let t = 0, e = 0;
    const i = this.sizesArray.length;
    if (this.sizesArray.forEach((function(e) {
      t += e;
    })), t > 100) {
      e = 100 / i, this.sizesArray = [];
      for (let t = 0; t < i; t++) this.sizesArray.push(e);
    }
  }
  //KNOB
  knobLeftClicked() {
    //add class to make the transition smooth
    const t = this.el.querySelectorAll("gxg-split");
    t.forEach((function(t) {
      t.classList.add("smooth-transition");
    })), this.draggingState = !0;
    const e = this.el.querySelector(".middle-line");
    if (e.style.backgroundColor = "var(--color-on-primary)", setTimeout(function() {
      this.draggingState = !1, e.style.backgroundColor = "var(--gray-03)";
    }.bind(this), 450), this.forceCollapseZero) if (this.rightCollapsedToZero) {
      //Right split is collapsed to zero. Set sizes to last saved positions
      this.split.setSizes(this.currentSizes), this.rightCollapsedToZero = !1;
      const t = this.el.querySelector(".middle-line");
      t.style.opacity = "1", t.style.pointerEvents = "auto";
      this.el.querySelector(".right-knob").style.pointerEvents = "auto";
      this.el.querySelector(".left-knob").style.top = "-36px";
    } else {
      this.currentSizes = this.split.getSizes();
      const e = t[0], i = t[1];
      "horizontal" === this.direction ? (e.style.width = "0", i.style.width = "calc(100% - 8px)", 
      this.leftCollapsedToZero = !0) : "vertical" === this.direction && (e.style.height = "0", 
      i.style.height = "calc(100% - 8px)", this.leftCollapsedToZero = !0);
      this.el.querySelector(".left-knob").style.pointerEvents = "none";
      const r = this.el.querySelector(".middle-line");
      r.style.opacity = "0", r.style.pointerEvents = "none";
      this.el.querySelector(".right-knob").style.top = "-40px";
    } else this.split.collapse(0);
    this.detectDragEndReachedMinimum();
  }
  knobRightClicked() {
    //add class to make the transition smooth
    const t = this.el.querySelectorAll("gxg-split");
    t.forEach((function(t) {
      t.classList.add("smooth-transition");
    })), this.draggingState = !0;
    const e = this.el.querySelector(".middle-line");
    if (e.style.backgroundColor = "var(--color-on-primary)", setTimeout(function() {
      this.draggingState = !1, e.style.backgroundColor = "var(--gray-03)";
    }.bind(this), 450), this.forceCollapseZero) if (this.leftCollapsedToZero) {
      //Left split is collapsed to zero. Set sizes to last saved positions
      this.split.setSizes(this.currentSizes), this.leftCollapsedToZero = !1;
      const t = this.el.querySelector(".middle-line");
      t.style.opacity = "1", t.style.pointerEvents = "auto";
      this.el.querySelector(".left-knob").style.pointerEvents = "auto";
      this.el.querySelector(".right-knob").style.top = "-20px";
    } else {
      this.currentSizes = this.split.getSizes();
      const e = t[0], i = t[1];
      "horizontal" === this.direction ? (e.style.width = "calc(100% - 8px)", i.style.width = "0", 
      this.rightCollapsedToZero = !0) : "vertical" === this.direction && (e.style.height = "calc(100% - 8px)", 
      i.style.height = "0", this.rightCollapsedToZero = !0);
      this.el.querySelector(".right-knob").style.pointerEvents = "none";
      const r = this.el.querySelector(".middle-line");
      r.style.opacity = "0", r.style.pointerEvents = "none";
      this.el.querySelector(".left-knob").style.top = "-16px";
    } else this.split.collapse(1);
    this.detectDragEndReachedMinimum();
  }
  knobLeftOver() {
    this.el.classList.add("knob-left-hover");
  }
  knobLeftOut() {
    this.el.classList.remove("knob-left-hover");
  }
  knobRightOver() {
    this.el.classList.add("knob-right-hover");
  }
  knobRightOut() {
    this.el.classList.remove("knob-right-hover");
  }
  //DRAG FUNCS
  onDragStartFunc() {
    this.draggingState = !0;
    this.el.querySelectorAll("gxg-split").forEach((function(t) {
      t.classList.remove("smooth-transition");
    }));
    this.el.querySelector(".middle-line").style.backgroundColor = "var(--color-on-primary)";
  }
  onDragFunc() {
    this.detectDragEndReachedMinimum(), this.dragging.emit("dragging");
  }
  onDragEndFunc() {
    this.draggingState = !1, this.dragEnded.emit("dragg ended");
    this.el.querySelector(".middle-line").style.backgroundColor = "var(--gray-03)";
  }
  detectDragEndReachedMinimum() {
    let t;
    "horizontal" === this.direction ? t = this.el.clientWidth : "vertical" === this.direction && (t = this.el.clientHeight);
    //actual sizes in percentages
        const e = this.split.getSizes()[1], i = this.split.getSizes()[0], r = Math.trunc(e * t / 100), o = Math.trunc(i * t / 100);
    r < this.minSizeArray[1] + 15 && r > this.minSizeArray[1] - 15 || o < this.minSizeArray[0] + 15 && o > this.minSizeArray[0] - 15 ? (this.el.classList.add("gutter-reached-end"), 
    setTimeout(function() {
      this.el.classList.remove("gutter-reached-end");
    }.bind(this), 350)) : (this.el.classList.remove("gutter-reached-left"), this.el.classList.remove("gutter-reached-right")), 
    //if guttter reached right:
    r < this.minSizeArray[1] + 15 && r > this.minSizeArray[1] - 15 && (this.forceCollapseZero || (this.el.classList.add("gutter-reached-right"), 
    this.el.classList.remove("gutter-reached-left"))), 
    //if guttter reached left:
    o < this.minSizeArray[0] + 15 && o > this.minSizeArray[0] - 15 && (this.forceCollapseZero || (this.el.classList.add("gutter-reached-left"), 
    this.el.classList.remove("gutter-reached-right")));
  }
  /**
     * This method allows to collapse the split passsed as argument
     */  async collapse(t, e = !1) {
    if (e) {
      //Collapse to zero
      const e = this.el.querySelectorAll("gxg-split");
      e.forEach((function(t) {
        t.classList.add("smooth-transition");
      }));
      const i = e[0], r = e[1];
      if ("horizontal" === this.direction) {
        if (0 === t) {
          const t = this.el.querySelector(".left-knob");
          t.click(), t.click(), i.style.width = "0", r.style.width = "calc(100% - 8px)";
        } else if (1 === t) {
          const t = this.el.querySelector(".right-knob");
          t.click(), t.click(), i.style.width = "calc(100% - 8px)", r.style.width = "0";
        }
      } else if ("vertical" === this.direction) if (0 === t) {
        const t = this.el.querySelector(".left-knob");
        t.click(), t.click(), i.style.height = "0", r.style.height = "calc(100% - 8px)";
      } else if (1 === t) {
        const t = this.el.querySelector(".right-knob");
        t.click(), t.click(), i.style.height = "calc(100% - 8px)", r.style.height = "0";
      }
    } else if (0 === t) {
      this.el.querySelector(".left-knob").click();
    } else if (1 === t) {
      this.el.querySelector(".right-knob").click();
    }
  }
  render() {
    return i(r, {
      class: {
        "left-collapsed-to-zero": this.leftCollapsedToZero,
        "right-collapsed-to-zero": this.rightCollapsedToZero,
        dragging: this.draggingState
      }
    }, i("slot", null));
  }
  get el() {
    return o(this);
  }
};

c.style = ':host{display:block;width:100%;height:100%;overflow:hidden}:host ::slotted(.gutter-horizontal),:host ::slotted(.gutter-vertical){-webkit-transition:background-color 0.25s;transition:background-color 0.25s;background-color:var(--gray-01)}:host ::slotted(.gutter-horizontal){height:100%;float:left;cursor:col-resize;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;position:relative}:host ::slotted(.gutter-horizontal):after{right:-5px}:host ::slotted(.gutter-horizontal):before{left:-5px}:host ::slotted(.gutter-vertical){cursor:row-resize;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;align-items:center;background-color:var(--gray-01);position:relative}:host ::slotted(.gutter-vertical):after{right:50%;-webkit-transform:rotate(90deg) translateX(6px) translateY(-2px);transform:rotate(90deg) translateX(6px) translateY(-2px)}:host ::slotted(.gutter-vertical):before{left:50%;-webkit-transform:rotate(90deg) translateX(-6px) translateY(2px);transform:rotate(90deg) translateX(-6px) translateY(2px)}:host([knob=bidirectional]) ::slotted(.gutter-horizontal):after,:host([knob=bidirectional]) ::slotted(.gutter-horizontal):before,:host([knob=bidirectional]) ::slotted(.gutter-vertical):after,:host([knob=bidirectional]) ::slotted(.gutter-vertical):before{content:"";width:0;height:0;border-top:4px solid transparent;border-bottom:4px solid transparent;z-index:10;position:relative;pointer-events:none;opacity:0;pointer-events:none;-webkit-transition:0.25s all;transition:0.25s all}:host([knob=bidirectional]) ::slotted(.gutter-horizontal):after,:host([knob=bidirectional]) ::slotted(.gutter-vertical):after{border-left:3px solid var(--gray-03)}:host([knob=bidirectional]) ::slotted(.gutter-horizontal):before,:host([knob=bidirectional]) ::slotted(.gutter-vertical):before{border-right:3px solid var(--gray-03)}:host([knob=bidirectional]) ::slotted(.gutter-horizontal):after{bottom:-19px;right:1px}:host([knob=bidirectional]) ::slotted(.gutter-horizontal):before{top:-19px;left:1px}:host([knob=bidirectional]) ::slotted(.gutter-vertical):after{bottom:6px;right:23px}:host([knob=bidirectional]) ::slotted(.gutter-vertical):before{top:6px;left:24px}:host([knob=bidirectional]) ::slotted(.gutter-horizontal:hover):after,:host([knob=bidirectional]) ::slotted(.gutter-vertical:hover):after{opacity:1}:host([knob=bidirectional]) ::slotted(.gutter-horizontal:hover):before,:host([knob=bidirectional]) ::slotted(.gutter-vertical:hover):before{opacity:1}:host(.knob-left-hover) ::slotted(.gutter-horizontal):before,:host(.knob-left-hover) ::slotted(.gutter-vertical):before{border-top:4px solid transparent;border-bottom:4px solid transparent;border-right:3px solid var(--color-primary-hover)}:host(.knob-right-hover) ::slotted(.gutter-horizontal):after,:host(.knob-right-hover) ::slotted(.gutter-vertical):after{border-top:4px solid transparent;border-bottom:4px solid transparent;border-left:3px solid var(--color-primary-hover)}:host(.left-collapsed-to-zero) ::slotted(.gutter),:host(.right-collapsed-to-zero) ::slotted(.gutter){pointer-events:none}:host(.collapsed-to-zero) ::slotted(.knob){pointer-events:auto}:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):before,:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):before{opacity:0;pointer-events:none}:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):after,:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):after{opacity:1}:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):after{bottom:0}:host(.left-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):after{right:3px}:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):after,:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):after{opacity:0;pointer-events:none}:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):before,:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):before{opacity:1}:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-horizontal):before{top:0}:host(.right-collapsed-to-zero[knob=bidirectional]) ::slotted(.gutter-vertical):before{left:3px}:host(.gutter-reached-right[knob=bidirectional]) ::slotted(.gutter-horizontal):after,:host(.gutter-reached-right[knob=bidirectional]) ::slotted(.gutter-vertical):after{opacity:0;pointer-events:none}:host(.gutter-reached-left[knob=bidirectional]) ::slotted(.gutter-horizontal):before,:host(.gutter-reached-left[knob=bidirectional]) ::slotted(.gutter-vertical):before{opacity:0;pointer-events:none}:host(.dragging) ::slotted(.gutter-horizontal),:host(.dragging) ::slotted(.gutter-vertical){background-color:var(--color-primary-hover)}:host(.dragging) ::slotted(.gutter-horizontal):after,:host(.dragging) ::slotted(.gutter-vertical):after{border-top:4px solid transparent;border-bottom:4px solid transparent;border-left:3px solid var(--color-on-primary)}:host(.dragging) ::slotted(.gutter-horizontal):before,:host(.dragging) ::slotted(.gutter-vertical):before{border-top:4px solid transparent;border-bottom:4px solid transparent;border-right:3px solid var(--color-on-primary)}:host(.dragging) ::slotted(.gutter-horizontal) .middle-line,:host(.dragging) ::slotted(.gutter-vertical) .middle-line{background-color:red}';

export { c as gxg_splitter }